; ********** Programmbeginn **********
(Defun C:K3 ()

;Systemvariablen werden gesichert
  (SVS)
  
;Systemvariablen werden gesetzt
 (Setvar "Cmdecho" 0)
 (Setvar "Blipmode" 0)

;Meldung Layer... Spter in Diabox 
 (Prompt "\nVorsicht!!! Layer umschalten...\n")

;Datei wird gesucht
 (setq slb (findfile "kan-roh.slb"))
 (if (= slb nil)
  (alert "AutoCAD kann die Zusatzdatei kan-roh.slb nicht finden!\n
          berprfen Sie, ob sich diese Datei in einem AutoCAD Verzeichnis befindet!")
  );end if

;Funktion Dialogbox suchen und ffnen
  (K3LRS-DCL)


;Zeilen am 12.7.03 deaktiviert
;  (Setq KB2 (Atof KB2))
;  (Setq KB3 (Atof KB3))
;  (Setq LA (Atof LA))
;  (Setq DW (Atof DW))

; (Setvar "OSMODE" 1)
; (Setq P1 (Getpoint "\nEinfgepunkt: END von "))
; (Setvar "OSMODE" 0)

); Defun


; ********** Systemvariablen werden gespeichert **********
(Defun SVS ()
 (Command "ZURCK" "B")
 (Setq AL (getvar "Clayer"))
 (Setq CM (Getvar "Cmdecho"))
 (Setq BL (Getvar "Blipmode"))
 (Setq OS (Getvar "Osmode"))
)

; ********** Systemvariablen zurcksetzen **********
(Defun SVZ ()
 (Setvar "Clayer" AL)
 (Setvar "Cmdecho" CM)
 (Setvar "Osmode" OS)
 (Setvar "Blipmode" BL)  
 (Command "ZURCK" "E")

	;Auswirkung der Zeilen in BOGEN30G_IWT.LSP prfen
	; (defun *error* (emsg)
	; (princ emsg)
	; (altsv)
  
)


; ********** Dialogbox suchen und ffnen **********
(defun K3LRS-DCL ()

;Datei wird gesucht
 (setq dcl (findfile "k3lrs.dcl"))
 (if (= dcl nil)
  (alert "AutoCAD kann die Zusatzdatei k3lrs.dcl nicht finden!\n
          berprfen Sie, ob sich diese Datei in einem AutoCAD Verzeichnis befindet!")
  );end if

;Load_dialog aktiviert die DCL Datei
 (setq dcl_id (load_dialog "k3lrs.dcl"))
 (if (not (new_dialog "k3lrs" dcl_id)) (exit))

;Parameter der Diafelder in der DCL Datei werden gesetzt
 (setq Bre (dimx_tile "K3L"))
 (setq Hoe (dimy_tile "K3L"))
 (start_image "K3L")
 (slide_image 0 0 bre hoe "KAN-ROH(K3L)")
 (end_image)

 (setq Bre (dimx_tile "K3S"))
 (setq Hoe (dimy_tile "K3S"))
 (start_image "K3S")
 (slide_image 0 0 bre hoe "KAN-ROH(K3S)")
 (end_image)

 (setq Bre (dimx_tile "K3R"))
 (setq Hoe (dimy_tile "K3R"))
 (start_image "K3R")
 (slide_image 0 0 bre hoe "KAN-ROH(K3R)")
 (end_image)

 ;Aktiviert Funktion je nach gewhltem Diafeld
; FEHLER - FEHLER - FEHLER - 
;xxxxx HIER KOMME ICH LEIDER NICHT WEITER xxxxx
;------------------------------------------------------------------------------------------------------------------
 (action_tile "KB3L"  "(setq KB3L (get_tile \"KB3L\"))")
 (action_tile "KB3R"  "(setq KB3R (get_tile \"KB3R\"))")
 (action_tile "KB3S"  "(setq KB3S (get_tile \"KB3S\"))")

;------------------------------------------------------------------------------------------------------------------


 (action_tile "cancel" "(done_dialog)")
 (setq OK (start_dialog))
 (unload_dialog dcl_id)
 (princ)
);end defun


; ********** Definition der Konstruktionspunkte **********
(Defun K3L ()
 (Setq P2 (List (+ (Car P1) KB2) (Cadr P1)))
 (Setq P3 (List (- (Car P1) 2) (Cadr P1)))
 (Setq P4 (List (+ (Car P2) 2) (Cadr P2)))
 (Setq P5 (List (Car P1) (- (Cadr P1) 1)))
 (Setq P6 (List (Car P2) (- (Cadr P2) 1)))
 (Setq P7 (List (Car P1) (+ (Cadr P1) 1)))
 (Setq P8 (List (Car P2) (+ (Cadr P2) 1)))
 (Setq P9 (List (+ (Car P1) (/ KB3 2)) (Cadr P1)))
 (Setq P10 (List (Car P9) (+ (Cadr P9) LA)))
 (Setq P11 (List (- (Car P10) (/ KB3 2)) (Cadr P10)))
 (Setq P12 (List (+ (Car P10) (/ KB3 2)) (Cadr P10)))
  (OBJZ)
); Defun


(Defun K3R ()
 (Setq P2 (List (+ (Car P1) KB2) (Cadr P1)))
 (Setq P3 (List (- (Car P1) 2) (Cadr P1)))
 (Setq P4 (List (+ (Car P2) 2) (Cadr P2)))
 (Setq P5 (List (Car P1) (- (Cadr P1) 1)))
 (Setq P6 (List (Car P2) (- (Cadr P2) 1)))
 (Setq P7 (List (Car P1) (+ (Cadr P1) 1)))
 (Setq P8 (List (Car P2) (+ (Cadr P2) 1)))
 (Setq P9 (List (- (Car P2) (/ KB3 2)) (Cadr P1)))
 (Setq P10 (List (Car P9) (+ (Cadr P9) LA)))
 (Setq P11 (List (- (Car P10) (/ KB3 2)) (Cadr P10)))
 (Setq P12 (List (+ (Car P10) (/ KB3 2)) (Cadr P10)))
  (OBJZ)
); Defun


(Defun K3S ()
 (Setq P2 (List (+ (Car P1) KB2) (Cadr P1)))
 (Setq P3 (List (- (Car P1) 2) (Cadr P1)))
 (Setq P4 (List (+ (Car P2) 2) (Cadr P2)))
 (Setq P5 (List (Car P1) (- (Cadr P1) 1)))
 (Setq P6 (List (Car P2) (- (Cadr P2) 1)))
 (Setq P7 (List (Car P1) (+ (Cadr P1) 1)))
 (Setq P8 (List (Car P2) (+ (Cadr P2) 1)))
 (Setq P9 (List (+ (Car P1) (/ KB2 2)) (Cadr P1)))
 (Setq P10 (List (Car P9) (+ (Cadr P9) LA)))
 (Setq P11 (List (- (Car P10) (/ KB3 2)) (Cadr P10)))
 (Setq P12 (List (+ (Car P10) (/ KB3 2)) (Cadr P10)))
  (OBJZ)
); Defun


; ********** Objekt zeichnen **********
(Defun OBJZ ()
 (Command "LINIE" P5 P6 "")
 (DREH)
 (ND1)
 (Command "LINIE" P3 P4 "")
 (DREH)
 (Command "LINIE" P7 P8 "")
 (DREH)
 (ND1)
 (Command "LINIE" P1 P11 "")
 (DREH)
 (Command "LINIE" P2 P12 "")
 (DREH)
 (DAR)

 (SVZ)
 (Princ)
); Defun




























; ********** Hilfsprogramme **********


(Defun DKB2 ()
 (If (not TKB2)(setq TKB2 ""))
 (Setq KB2 (Getstring (Strcat "\n1. Kanalbreite <"TKB2">: ")))
 (If (/= KB2 "") (Setq TKB2 KB2))
 (Setq KB2 TKB2)
 (Setq KB2 (Atof KB2))
 (If (<= KB2 0)
  (And (Princ "\nWert muss positiv und ungleich Null sein.") (DKB2))
 );If
)

(Defun DKB3 ()
 (If (not TKB3)(setq TKB3 ""))
 (Setq KB3 (Getstring (Strcat "\n2. Kanalbreite <"TKB3">: ")))
 (If (/= KB3 "") (Setq TKB3 KB3))
 (Setq KB3 TKB3)
 (Setq KB3 (Atof KB3))
 (If (<= KB3 0)
  (And (Princ "\nWert muss positiv und ungleich Null sein.") (DKB3))
 );If
)

(Defun DLA ()
 (If (not TLA)(setq TLA ""))
 (Setq LA (Getstring (Strcat "\nFormteillnge <"TLA">: ")))
 (If (/= LA "") (Setq TLA LA))
 (Setq LA TLA)
 (Setq LA (Atof LA))
 (If (<= LA 0)
  (And (Princ "\nWert muss positiv und ungleich Null sein.") (DLA))
 );If
)

(Defun DDW ()
 (If (not TDW)(setq TDW ""))
 (Setq DW (Getstring (Strcat "\nDrehwinkel <"TDW">: ")))
 (If (/= DW "") (Setq TDW DW))
 (Setq DW TDW)
 (Setq DW (Atof DW))
)

(Defun DREH ()
 (Command "DREHEN" "L" "" P1 DW)
)

(Defun ND1 ()
 (Command "NDERN" "L" "" "EI" "F" "1" "")
)

(Defun DAR ()
 (Initget "Ja Nein")
 (Setq AR (Getkword "\nAuf Rohr bergehen (J/N) <N>: "))
 (If
  (Or (= AR "J") (= AR "JA") (= AR "j") (= AR "ja") (= AR "Ja") (= AR "jA"))
  (Command "PLINIE" P1 P10 P2 "" "DREHEN" "L" "" P1 DW "NDERN" "L" "" "EI" "F" "1" "" "URSPRUNG" "L")
 );If
)









